MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0028247Community[OCCT] OCCT:Meshpublic2016-12-19 18:372019-10-19 16:46
ReporterMarkus 
Assigned Toabv 
PrioritynormalSeverityminor 
StatusresolvedResolutionopen 
PlatformOSOS Version
Product Version[OCCT] 7.0.0 
Target Version[OCCT] 7.5.0*Fixed in Version 
Summary0028247: Effect of minSize parameter of BRepMesh_IncrementalMesh seems to be too strong
DescriptionWhen the minSize parameter is used for the appended face, the number of triangles is drastically reduced. According to documentation, MinSize defines the minimal allowed size of mesh element. But the mesh which is created without minSize does not seem to have elements with smaller size. At least, the effect should not be so big here.

The behaviour is similar in 7.1.0.
Steps To Reproducerestore face.brep f
whatis f
pload ALL
tolerance f
tclean f
incmesh f 0.59
trinfo f
# => 4357 triangles
tclean f
incmesh f 0.59 -a 11.45
trinfo f
# => 14412 triangles
tclean f
incmesh f 0.59 -a 11.45 -min 0.035
trinfo f
# => 2830 triangles

TagsNo tags attached.
Test case numberbugs mesh bug28247
Attached Fileszip file icon face.zip (534,550 bytes) 2016-12-19 18:37
png file icon without minSize.png (161,814 bytes) 2016-12-19 18:37
png file icon with minSize.png (191,216 bytes) 2016-12-19 18:38
png file icon case1.png (40,955 bytes) 2019-10-11 22:49
png file icon case2.png (55,456 bytes) 2019-10-11 22:49
png file icon case3.png (58,010 bytes) 2019-10-11 22:49

- Relationships

-  Notes
(0069978)
mkv (tester)
2017-08-28 14:20

Problem described in issue is reproduced on current state of OCCT.
(0088058)
oan (developer)
2019-10-11 22:59

Dear Andrey,

current version of BRepMesh provides different results comparing to reported problem:

incmesh a 0.59
#This shape contains 1235 triangles.

incmesh a 0.59 -a 11.45
#This shape contains 6438 triangles.

incmesh a 0.59 -a 11.45 -min 0.035
#This shape contains 7079 triangles.

I suppose the issue can be closed now.

However, it could be fair to synchronize description of -min parameter of incmesh command and MinSize parameter of the algorithm itself.

It is suggested to take description of -min parameter as reference as soon as it reflects the notion of this parameter more careful:

minimum size parameter limiting size of triangle's edges to prevent sinking into amplification in case of distorted curves and surfaces
(0088072)
abv (manager)
2019-10-13 09:09

Oleg, I completely agree that documentation shall be improved to avoid misinterpretation of meaning of the parameter.

Regarding the numbers you gave in 0028247:0088058, can you explain why triangulation with -min parameter has larger number of triangles, while logically it should contain less? Is that due to default value of minSize being greater than 0? If so, this should also be documented, I suppose.
(0088073)
oan (developer)
2019-10-13 13:34

Andrey,

to my understanding, case with different number of triangles with and without -min parameter is caused by optimization procedure used by BRepMesh which is remembered as Control method. It is limited by 11 iterations.

So, potentially, with -min parameter we can skip some areas processed in default mode and refine another parts of face more strongly which could lead to difference in triangles number. Moreover, MinSize parameter limits discretization methods, so even edge tesellations could violate specified deflection parameter trying to fit to -min value. This causes the situation when face has more areas to be refined comparing to result obtained without -min parameter.
(0088325)
git (administrator)
2019-10-19 16:29

Branch CR28247 has been created by oan.

SHA-1: 661809190aefcfe6603045f4682a19e0d9f47ea3


Detailed log of new commits:

Author: oan
Date: Sat Oct 19 16:28:55 2019 +0300

    0028247: Effect of minSize parameter of BRepMesh_IncrementalMesh seems to be too strong
    Updated description of MinSize parameter of IMeshTools_Parameters
(0088326)
git (administrator)
2019-10-19 16:45

Branch CR28247 has been updated by oan.

SHA-1: 2c30036a1b10bb0113b29ff3d332db8c7976b8de


Detailed log of new commits:

Author: oan
Date: Sat Oct 19 16:44:20 2019 +0300

    # updated test case

(0088327)
oan (developer)
2019-10-19 16:46

Please review changes made according to the note above.

- Issue History
Date Modified Username Field Change
2016-12-19 18:37 Timo New Issue
2016-12-19 18:37 Timo Assigned To => kgv
2016-12-19 18:37 Timo File Added: face.zip
2016-12-19 18:37 Timo File Added: without minSize.png
2016-12-19 18:38 Timo File Added: with minSize.png
2016-12-19 18:38 kgv Assigned To kgv => msv
2016-12-19 18:38 kgv Category OCCT:Visualization => OCCT:Mesh
2017-01-26 15:07 Timo Assigned To msv => oan
2017-05-31 15:35 Timo Reporter Timo => Markus
2017-07-20 12:43 oan Target Version 7.2.0 => 7.3.0
2017-08-28 14:20 mkv Test case number => bugs mesh bug28247
2017-08-28 14:20 mkv Note Added: 0069978
2018-02-25 21:14 abv Target Version 7.3.0 => 7.4.0
2019-09-04 13:04 abv Target Version 7.4.0 => 7.5.0*
2019-10-11 22:49 oan File Added: case1.png
2019-10-11 22:49 oan File Added: case2.png
2019-10-11 22:49 oan File Added: case3.png
2019-10-11 22:59 oan Note Added: 0088058
2019-10-11 22:59 oan Assigned To oan => abv
2019-10-11 22:59 oan Status new => feedback
2019-10-13 09:09 abv Note Added: 0088072
2019-10-13 09:09 abv Assigned To abv => oan
2019-10-13 09:09 abv Status feedback => assigned
2019-10-13 13:34 oan Note Added: 0088073
2019-10-13 13:34 oan Assigned To oan => abv
2019-10-13 13:34 oan Status assigned => feedback
2019-10-19 16:29 git Note Added: 0088325
2019-10-19 16:45 git Note Added: 0088326
2019-10-19 16:46 oan Note Added: 0088327
2019-10-19 16:46 oan Status feedback => resolved


Copyright © 2000 - 2019 MantisBT Team
Powered by Mantis Bugtracker